<template>
  <v-app>
    <!-- spinner -->
    <div class="text-center">
      <v-dialog v-model="dialog_loader" hide-overlay persistent width="300">
        <v-card color="#428bca" dark>
          <v-card-text class="text-center" style="color: white">
            Wait . . .
            <v-progress-linear
              indeterminate
              color="white"
              class="mb-0"
            ></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>
    <!-- spinner -->

    <!-- icon-top-onScroll -->
    <v-btn
      v-scroll="onScroll"
      v-show="fab"
      fab
      dark
      fixed
      bottom
      right
      color="#428bca"
      @click="toTop"
    >
      <v-icon>mdi-chevron-up</v-icon>
    </v-btn>
    <!-- icon-top-onScroll -->

    <!-- table hospital -->
    <v-row>
      <v-col cols="12" lg="12" md="12" sm="12">
        <v-card>
          <v-container grid-list-xs>
            <v-row>
              <v-col cols="12" lg="12" md="12" sm="12">
                <v-card-title><h1>Hospital</h1></v-card-title>
                <div>
                  <v-card-title>
                    <v-btn
                      class="mr-1"
                      @click="dialog_add_hospital = true"
                      type="button"
                      color="#428bca"
                      small
                      dark
                      ><v-icon small class="pr-1">mdi-plus-box</v-icon>
                      Add Hospital
                    </v-btn>
                    <v-spacer></v-spacer>
                    <v-text-field
                      v-model="search"
                      append-icon="mdi-magnify"
                      label="Search Hospital Name"
                      single-line
                      hide-details
                    ></v-text-field>
                  </v-card-title>
                  <v-data-table
                    :headers="headers"
                    :items="all_hospital"
                    :search="search"
                  >
                    <template v-slot:item.enddate="{ item }">
                      <span v-if="item.enddate != ''">
                        {{
                          new Date(item.enddate).toISOString().substr(0, 10)
                        }}</span
                      >
                    </template>
                    <template v-slot:item.status="{ item }">
                      <span
                        class="ma-2"
                        v-if="item.status == 'success'"
                        style="color: green"
                        color="success"
                      >
                        Valid
                      </span>
                      &nbsp;&nbsp;
                      <span
                        class="ma-2"
                        v-if="item.status == 'fail'"
                        color="error"
                        style="color: red"
                      >
                        Expire
                      </span>
                    </template>
                    <template v-slot:item.actions="{ item }">
                      <v-tooltip top>
                        <template v-slot:activator="{ on, attrs }">
                          <v-icon
                            v-bind="attrs"
                            v-on="on"
                            small
                            class="mx-0"
                            @click="edit_hospital(item)"
                            color="teal"
                          >
                            mdi-pencil
                          </v-icon>
                        </template>
                        <span>Edit</span>
                      </v-tooltip>
                      &nbsp;&nbsp;
                      <v-tooltip top>
                        <template v-slot:activator="{ on, attrs }">
                          <v-icon
                            v-bind="attrs"
                            v-on="on"
                            small
                            class="mx-0"
                            @click="delete_hospital(item)"
                            color="error"
                          >
                            mdi-delete
                          </v-icon>
                        </template>
                        <span>Delete</span>
                      </v-tooltip>
                    </template>
                  </v-data-table>
                </div>
              </v-col>
            </v-row>
          </v-container>
        </v-card>
      </v-col>
    </v-row>
    <!-- table hospital -->

    <!-- dialog_add_hospital -->
    <v-dialog v-model="dialog_add_hospital" max-width="500px" persistent>
      <v-card>
        <v-card-title
          class="headline"
          style="color: white; background: #428bca"
        >
          Add Hospital
        </v-card-title>
        <v-form ref="form_add_hospital">
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_add_hospital.hospital_name_th"
                    :rules="hospital_nameRules"
                    label="hospital name"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_add_hospital.tel"
                    :rules="phoneRules"
                    label="phone"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <v-autocomplete
                    :items="list_package_name"
                    item-text="package_name"
                    outlined
                    dense
                    return-object=""
                    v-model="form_add_hospital.package_name"
                    :rules="package_nameRules"
                    label="package name"
                  ></v-autocomplete>
                </v-col>
                <v-col cols="12" sm="12" md="12">
                  <!-- date picker start date -->
                  <!-- MenuAddStartDate -->
                  <v-menu
                    ref="MenuAddStartDate"
                    v-model="MenuAddStartDate"
                    :rules="form_add_hospital.hospital_nameRules"
                    :close-on-content-click="false"
                    :return-value.sync="form_add_hospital.delay_time"
                    transition="scale-transition"
                    offset-y
                    min-width="290px"
                  >
                    <template v-slot:activator="{ on, attrs }">
                      <v-text-field
                        v-model="form_add_hospital.delay_time"
                        label="Start Date"
                        append-icon="mdi-calendar-month-outline"
                        :rules="rule_date"
                        readonly
                        v-bind="attrs"
                        v-on="on"
                        outlined
                        dense
                      ></v-text-field>
                    </template>
                    <v-date-picker
                      v-model="form_add_hospital.delay_time"
                      :min="datenow"
                      no-title
                      scrollable
                    >
                      <v-spacer></v-spacer>

                      <v-btn text color="primary" @click="MenuAddStartDate = false">
                        Cancel
                      </v-btn>

                      <v-btn
                        text
                        color="primary"
                        @click="$refs.MenuAddStartDate.save(form_add_hospital.delay_time)"
                      >
                        OK
                      </v-btn>
                    </v-date-picker>
                  </v-menu>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>
        </v-form>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" @click="cancel_add" style="color: white">
            Cancel
          </v-btn>
          <v-btn color="blue" @click="save_add" style="color: white">
            Save
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- dialog_add_hospital -->

    <!-- dialog_edit_hospital -->
    <v-dialog v-model="dialog_edit_hospital" max-width="650px" persistent>
      <v-card>
        <v-card-title
          class="headline"
          style="color: white; background: #428bca"
        >
          Edit Hospital
        </v-card-title>
        <v-form ref="form_edit_hospital">
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_edit_hospital.hospital_name_th"
                    :rules="hospital_nameRules"
                    label="hospital name"
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="12" md="12">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_edit_hospital.po_number"
                    label="po number"
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="6" md="6">
                  <v-autocomplete
                    :items="list_package_name"
                    item-text="package_name"
                    outlined
                    dense
                    return-object=""
                    v-model="form_edit_hospital.package_name"
                    :rules="package_nameRules"
                    label="package name"
                  ></v-autocomplete>
                </v-col>

                <v-col cols="12" sm="6" md="6">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_edit_hospital.flim_upload"
                    :rules="film_upload_Rules"
                    label="film upload"
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="12" md="12">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_edit_hospital.tel"
                    :rules="phoneRules"
                    label="phone"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <!-- date picker start date -->
                  <!-- MenuEditStartDate -->
                  <v-menu
                    ref="MenuEditStartDate"
                    v-model="MenuEditStartDate"
                    :rules="form_add_hospital.hospital_nameRules"
                    :close-on-content-click="false"
                    :return-value.sync="form_edit_hospital.startdate"
                    transition="scale-transition"
                    offset-y
                    min-width="290px"
                  >
                    <template v-slot:activator="{ on, attrs }">
                      <v-text-field
                        v-model="form_edit_hospital.startdate"
                        label="Start Date"
                        prepend-icon="mdi-calendar-month-outline"
                        :rules="rule_date"
                        readonly
                        v-bind="attrs"
                        v-on="on"
                      ></v-text-field>
                    </template>
                    <v-date-picker
                      v-model="form_edit_hospital.startdate"
                      no-title
                      scrollable
                    >
                      <v-spacer></v-spacer>
                      <v-btn text color="primary" @click="MenuEditStartDate = false">
                        Cancel
                      </v-btn>
                      <v-btn
                        text
                        color="primary"
                        @click="$refs.MenuEditStartDate.save(form_edit_hospital.startdate)"
                      >
                        OK
                      </v-btn>
                    </v-date-picker>
                  </v-menu>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <!-- date picker end date -->
                  <!-- MenuEditEndDate -->
                  <v-menu
                    ref="MenuEditEndDate"
                    v-model="MenuEditEndDate"
                    :close-on-content-click="false"
                    :return-value.sync="form_edit_hospital.enddate"
                    transition="scale-transition"
                    offset-y
                    min-width="290px"
                  >
                    <template v-slot:activator="{ on, attrs }">
                      <v-text-field
                        v-model="form_edit_hospital.enddate"
                        :rules="rule_date"
                        label="End Date"
                        prepend-icon="mdi-calendar-month-outline"
                        readonly
                        v-bind="attrs"
                        v-on="on"
                      ></v-text-field>
                    </template>
                    <v-date-picker
                      v-model="form_edit_hospital.enddate"
                      no-title
                      scrollable
                    >
                      <v-spacer></v-spacer>

                      <v-btn text color="primary" @click="MenuEditEndDate = false">
                        Cancel
                      </v-btn>
                      <v-btn
                        text
                        color="primary"
                        @click="$refs.MenuEditEndDate.save(form_edit_hospital.enddate)"
                      >
                        OK
                      </v-btn>
                    </v-date-picker>
                  </v-menu>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>
        </v-form>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" @click="cancle_edit" style="color: white">
            Cancel
          </v-btn>
          <v-btn color="blue" @click="save_edit" style="color: white">
            Update
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- dialog_edit_hospital -->
  </v-app>
</template>

<script>
export default {
  name: "Hospital",
  data() {
    return {
      api: process.env.VUE_APP_API,
      fab: false,
      MenuEditStartDate: false,
      MenuEditEndDate: false,
      MenuAddStartDate: false,
      datenow: new Date().toISOString().substr(0, 10),
      dialog_add_hospital: false,
      dialog_edit_hospital: false,
      dialog_delete_hospital: false,
      dialog_loader: false,
      search: "",
      list_package_name: [],
      all_hospital: [],
      headers: [
        {
          text: "Hospital Name",
          align: "start",
          value: "hospital_name_th",
          sortable: false,
        },
        {
          text: "Package Name",
          align: "start",
          value: "package_name",
          sortable: false,
        },
        {
          text: "Status",
          align: "start",
          value: "status",
          sortable: false,
        },
        {
          text: "Expire Date Package",
          align: "start",
          value: "enddate",
          sortable: false,
        },
        {
          text: "Phone",
          align: "start",
          value: "tel",
          sortable: false,
        },
        { text: "Action", value: "actions", sortable: false },
      ],
      form_add_hospital: {
        hospital_name_th: "",
        tel: "",
        package_name: "",
        flim_upload: "",
        po_number: "",
        delay_time: new Date().toISOString().substr(0, 10),
      },
      // rule
      phoneRules: [
        (v) => !!v || "Please enter phone",
        (v) => (v || "").length === 10 || "Please enter 10 only!",
        (v) => /^([0-9])+$/.test(v) || "Please enter number only!",
      ],
      rule_date: [(v) => !!v || "Please choose date"],
      po_number_rules: [(v) => !!v || "Please enter po number"],
      film_upload_Rules: [(v) => !!v || "Please enter film upload"],
      package_nameRules: [(v) => !!v || "Please enter Package Name"],
      hospital_nameRules: [(v) => !!v || "Please enter hospital name"],
      form_edit_hospital: {},
      session_id: this.$cookies.get("info_login").session_id,
    };
  },

  mounted() {
    console.log("api -->", this.api);
    this.get_hospital();
    this.get_package();
  },

  methods: {
    onScroll(e) {
      if (typeof window === "undefined") return;
      const top = window.pageYOffset || e.target.scrollTop || 0;
      this.fab = top > 20;
    },

    toTop() {
      this.$vuetify.goTo(0);
    },

    get_package() {
      this.axios
        .get(process.env.VUE_APP_API + "/api/v3/package", {
          params: {
            userlog_id: this.$cookies.get("info_login").user_id,
          },
          headers: {
            Authorization: this.session_id,
          },
        })
        .then((response) => {
          console.log("response=>package", response.data.data);
          for (let index = 0; index < response.data.data.length; index++) {
            this.list_package_name.push(response.data.data[index]);
          }
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            window.location.href = this.api;
          });
        });
    },

    get_hospital() {
      this.dialog_loader = true;
      let CheckDateNow = new Date();
      console.log(CheckDateNow);
      this.axios
        .get(process.env.VUE_APP_API + "/api/v3/hospital_contract", {
          params: {
            userlog_id: this.$cookies.get("info_login").user_id,
          },
          headers: {
            Authorization: this.session_id,
          },
        })
        .then((response) => {
          console.log("response", response.data.data);
          this.dialog_loader = false;
          // ===> check date package expired table hospitals <=== //
          for (let index = 0; index < response.data.data.length; index++) {
            if (response.data.data[index].enddate == "") {
              console.log("empty_enddate");
            } else if (response.data.data[index].startdate == "") {
              console.log("empty_startdate");
            } else {
              let EndDatePackage = new Date(response.data.data[index].enddate);
              if (EndDatePackage < CheckDateNow) {
                response.data.data[index].status = "fail";
              } else {
                response.data.data[index].status = "success";
              }
            }
          }
          this.all_hospital = response.data.data;
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            window.location.href = this.api;
          });
        });
    },

    cancel_add() {
      this.$refs.form_add_hospital.reset();
      this.dialog_add_hospital = false;
    },

    save_add() {
      var set_form_package = {};
      if (!this.$refs.form_add_hospital.validate()) return;
      this.dialog_loader = true;
      this.dialog_add_hospital = false;
      set_form_package = this.form_add_hospital.package_name;
      set_form_package["hospital_name_th"] = this.form_add_hospital.hospital_name_th;
      set_form_package["tel"] = this.form_add_hospital.tel;
      set_form_package["userlog_id"] = this.$cookies.get("info_login").user_id;
      set_form_package["delay_time"] = this.form_add_hospital.delay_time;
      console.log("set_form_packgae", set_form_package);
      this.axios
        .post(process.env.VUE_APP_API + "/api/v3/hospital", set_form_package, {
          headers: {
            Authorization: this.session_id,
          },
        })
        .then((response) => {
          this.dialog_loader = false;
          console.log("response", response.data.data);
          this.$swal({
            icon: "success",
            title: "Success!",
            text: "Add hospital success.",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            this.get_hospital();
            this.$refs.form_add.reset();
          });
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            window.location.href = this.api;
          });
        });
    },

    edit_hospital(item) {
      console.log("edit_hospital:", item);
      this.form_edit_hospital = item;
      if (this.form_edit_hospital.enddate != "" && this.form_edit_hospital.startdate != "") {
        this.form_edit_hospital.startdate = new Date(item.startdate).toISOString().substr(0, 10);
        this.form_edit_hospital.enddate = new Date(item.enddate).toISOString().substr(0, 10);
        this.dialog_edit_hospital = true;
      } else {
        console.log("end_date = empty");
        this.form_edit_hospital.enddate = new Date(item.enddate).toISOString().substr(0, 10);
        this.dialog_edit_hospital = true;
      }
    },

    cancle_edit() {
      this.dialog_edit_hospital = false;
      this.$refs.form_edit_hospital.reset();
      this.get_hospital();
    },

    save_edit() {
      if (!this.$refs.form_edit_hospital.validate()) return;
      this.form_edit_hospital["userlog_id"] = this.$cookies.get("info_login").user_id;
      this.form_edit_hospital.enddate = new Date(this.form_edit_hospital.enddate);
      this.form_edit_hospital.startdate = new Date(this.form_edit_hospital.startdate);
      if (typeof this.form_edit_hospital.package_name === "string") {
        console.log("string");
      } else {
        console.log("json");
        this.form_edit_hospital["disease"] = this.form_edit_hospital.package_name.disease;
        this.form_edit_hospital["package_id"] = this.form_edit_hospital.package_name.package_id;
        this.form_edit_hospital["package_name"] = this.form_edit_hospital.package_name.package_name;
      }
      // console.log("finish", this.form_edit_hospital);
      this.dialog_edit_hospital = false;
      this.axios
        .put(
          process.env.VUE_APP_API + "/api/v3/hospital",
          this.form_edit_hospital,
          {
            headers: {
              Authorization: this.session_id,
            },
          }
        )
        .then(() => {
          this.dialog_edit_hospital = false;
          this.$swal({
            icon: "success",
            title: "Success!",
            text: "Edit hospital success.",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            this.get_hospital();
          });
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            window.location.href = this.api;
          });
        });
    },

    delete_hospital(item) {
      console.log(item);
      // this.dialog_delete_hospital = true;
      this.$swal({
        title: "Are you sure?",
        text: "Your want to delete this hospital",
        html:
          "Your want to delete this hospital , Your data will be lost.<br />",
        icon: "warning",
        allowOutsideClick: false,
        showCancelButton: true,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Yes, delete it!",
      }).then((result) => {
        if (result.value) {
          this.axios
            .delete(process.env.VUE_APP_API + "/api/v3/hospital", {
              params: {
                hospital_id: item.hospital_id,
                userlog_id: this.$cookies.get("info_login").user_id,
              },
              headers: {
                Authorization: this.session_id,
              },
            })
            .then(() => {
              this.$swal({
                icon: "success",
                title: "Success!",
                text: "Delete Package success.",
                confirmButtonText: "OK",
                allowOutsideClick: false,
              }).then(() => {
                this.get_hospital();
              });
            })
            .catch((error) => {
              this.dialog_loader = false;
              console.log("error", error);
              this.$swal({
                icon: "error",
                title: "Error!",
                text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
                confirmButtonText: "OK",
                allowOutsideClick: false,
              }).then(() => {
                window.location.href = this.api;
              });
            });
        }
      });
    },
  },
};
</script>

<style></style>
